#ifndef __SQLDB_H
#define __SQLDB_H

#include <string>
#include <sqlite.h>

using std::string;

class SqlDb
{
public:
    SqlDb();
    ~SqlDb();

    int identify(const string &path, time_t modtime);
    int identify(const string &path, time_t modtime, const string &checksum);

    time_t get_last();
    string get_title();
    string get_artist();
    int get_rating();

    void set_last(time_t last);
    void set_artist(const string &artist);
    void set_title(const string &title);
    void set_rating(int rating);

    int check_artist(const string &artist);
    int check_title(const string &title);

protected:
    void sql_create_table();
    void run_query(const string &query);
    void select_query(const string &query);
    void handle_error(const string &query);

    // shared db info
    int nrow, ncol;
    char **resultp, *errmsg;
    struct sqlite *db;

    // state cache
    int sid;
    string artist, title;
};

#endif
